Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle Security Developer Tools Security Engine Java API Reference 10g Release 3 (10.1.3) B25381-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.security.crypto.cert
Class KeyPairPKCS12

`java.lang.Object
oracle.security.crypto.cert.PKCS12
oracle.security.crypto.cert.KeyPairPKCS12`

All Implemented Interfaces:
  oracle.security.crypto.asn1.ASN1Object, oracle.security.crypto.util.Streamable

public class KeyPairPKCS12
extends PKCS12

A subclass of PKCS12 for processing exported key pairs, including PKCS12 object exported from Web browsers such as Netscape Navigator and Microsoft IE.

Constructor Summary
`KeyPairPKCS12()`
`KeyPairPKCS12(oracle.security.crypto.core.PrivateKeyPKCS8 pkcs8, java.util.Vector certChain, int mode)` Make a PKCS12 object containing the given certificate chain and private key.
`KeyPairPKCS12(oracle.security.crypto.core.PrivateKeyPKCS8 pkcs8, java.util.Vector certChain, int mode, java.lang.String friendlyName)` Make a PKCS12 object containing the given certificate chain and private key.
`KeyPairPKCS12(java.lang.String passwd, oracle.security.crypto.asn1.ASN1Sequence s)`
`KeyPairPKCS12(java.lang.String passwd, java.io.InputStream is)`
`KeyPairPKCS12(java.lang.String passwd, oracle.security.crypto.core.PrivateKeyPKCS8 pkcs8, java.util.Vector certChain, int mode)` Make a PKCS12 object encrypted with the specified password, and containing the given certificate chain and private key.
`KeyPairPKCS12(java.lang.String passwd, oracle.security.crypto.core.PrivateKeyPKCS8 pkcs8, java.util.Vector certChain, int mode, java.lang.String friendlyName)` Make a PKCS12 object encrypted with the specified password, and containing the given certificate chain and private key.

Method Summary
`X509` | `getBottomCert()`
`java.util.Vector` | `getCertificateChain()` Gets the certificate chain from this `KeyPairPKCS12` in order from bottom to top.
`oracle.security.crypto.core.PrivateKey` | `getPrivateKey()` Decrypts the `PrivateKeyPKCS8` enclosed in this `KeyPairPKCS12`'s `PKCS12ShroudedKeyBag`, using the password set for it (default is the parent `PKCS12`'s password).
`oracle.security.crypto.core.PrivateKey` | `getPrivateKey(java.lang.String passwd)` Decrypts the `PrivateKeyPKCS8` enclosed in this `KeyPairPKCS12`'s `PKCS12ShroudedKeyBag`, using the given password.
`oracle.security.crypto.core.PrivateKeyPKCS8` | `getPrivateKeyPKCS8()`
`void` | `input(oracle.security.crypto.asn1.ASN1Sequence s)` Reconstructs this object from its representation as an ASN.1 sequence.
`void` | `input(java.io.InputStream is)` Reconstructs this object by reading its DER encoding from the specified input stream.

Methods inherited from class oracle.security.crypto.cert.PKCS12
`addAuthSafe, getAuthSafes, getPassword, length, output, setAuthSafes, setPassword, toString, verify`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### KeyPairPKCS12

    public KeyPairPKCS12()

### KeyPairPKCS12

    public KeyPairPKCS12(oracle.security.crypto.core.PrivateKeyPKCS8 pkcs8,
                         java.util.Vector certChain,
                         int mode)

  Make a PKCS12 object containing the given certificate chain and private key.
Parameters:
  `pkcs8` - a PKCS8 private key
  `certChain` - a vector of `X509` certificates
  `mode` - the encryption mode for the certificate chain (use constants from `PKCS5`)

### KeyPairPKCS12

    public KeyPairPKCS12(oracle.security.crypto.core.PrivateKeyPKCS8 pkcs8,
                         java.util.Vector certChain,
                         int mode,
                         java.lang.String friendlyName)

  Make a PKCS12 object containing the given certificate chain and private key.
Parameters:
  `pkcs8` - A PKCS8 private key.
  `certChain` - A vector of `X509` certificates.
  `mode` - The encryption mode for the certificate chain (use constants from `PKCS5`).
  `friendlyName` - Friendly name for the key and bottom certificate.

### KeyPairPKCS12

    public KeyPairPKCS12(java.lang.String passwd,
                         oracle.security.crypto.core.PrivateKeyPKCS8 pkcs8,
                         java.util.Vector certChain,
                         int mode)

  Make a PKCS12 object encrypted with the specified password, and containing the given certificate chain and private key.
Parameters:
  `passwd` - the encryption password
  `pkcs8` - a PKCS8 private key
  `certChain` - a vector of `X509` certificates
  `mode` - the encryption mode for the certificate chain (use constants from `PKCS5`)

### KeyPairPKCS12

    public KeyPairPKCS12(java.lang.String passwd,
                         oracle.security.crypto.core.PrivateKeyPKCS8 pkcs8,
                         java.util.Vector certChain,
                         int mode,
                         java.lang.String friendlyName)

  Make a PKCS12 object encrypted with the specified password, and containing the given certificate chain and private key.
Parameters:
  `passwd` - the encryption password
  `pkcs8` - a PKCS8 private key
  `certChain` - a vector of `X509` certificates
  `mode` - the encryption mode for the certificate chain (use constants from `PKCS5`)
  `friendlyName` - friendly name for the key and bottom certificate

### KeyPairPKCS12

    public KeyPairPKCS12(java.lang.String passwd,
                         java.io.InputStream is)
                  throws java.io.IOException

### KeyPairPKCS12

    public KeyPairPKCS12(java.lang.String passwd,
                         oracle.security.crypto.asn1.ASN1Sequence s)
                  throws java.io.IOException

Method Detail

### input

    public void input(oracle.security.crypto.asn1.ASN1Sequence s)
               throws java.io.IOException

  Description copied from class: `PKCS12`
  Reconstructs this object from its representation as an ASN.1 sequence.
  Overrides:
    `input` in class `PKCS12`
  Parameters:
    `s` - The ASN.1 sequence representation of this object.
  Throws:
    `java.io.IOException`

### input

    public void input(java.io.InputStream is)
               throws java.io.IOException

  Description copied from class: `PKCS12`
  Reconstructs this object by reading its DER encoding from the specified input stream.
  Specified by:
    `input` in interface `oracle.security.crypto.util.Streamable`
  Overrides:
    `input` in class `PKCS12`
  Parameters:
    `is` - The input stream from which this object will be read.
  Throws:
    `java.io.IOException`

### getPrivateKeyPKCS8

    public oracle.security.crypto.core.PrivateKeyPKCS8 getPrivateKeyPKCS8()

### getPrivateKey

    public oracle.security.crypto.core.PrivateKey getPrivateKey()

  Decrypts the `PrivateKeyPKCS8` enclosed in this `KeyPairPKCS12`'s `PKCS12ShroudedKeyBag`, using the password set for it (default is the parent `PKCS12`'s password).
  See Also:
    `getPrivateKey(String passwd)`

### getPrivateKey

    public oracle.security.crypto.core.PrivateKey getPrivateKey(java.lang.String passwd)

  Decrypts the `PrivateKeyPKCS8` enclosed in this `KeyPairPKCS12`'s `PKCS12ShroudedKeyBag`, using the given password.
  See Also:
    `getPrivateKey()`

### getCertificateChain

    public java.util.Vector getCertificateChain()

  Gets the certificate chain from this `KeyPairPKCS12` in order from bottom to top.
  Returns:
    a `Vector` of `X509` certificates (possibly empty), or `null` if this `KeyPairPKCS12` was not constructed from an input stream.

### getBottomCert

    public X509 getBottomCert()

Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle Security Developer Tools Security Engine Java API Reference 10g Release 3 (10.1.3) B25381-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005, 2006 , Oracle. All rights reserved.